<?php
#0001 // never cut this line off! update plugin needs it!!!

		/* Copyright (c) 2004 Fabian Schneider - see '/doc/license.txt'    *\
       /*-------------------------------------------------------------------*\
      //       (>"<)                                                          |
     //        o", )            Copyright 2004 by Fabian Schneider            |
    //         (.(,) www.fabian-schneider.com  webmaster@fabian-schneider.com |
   //          '.'.J                    ICQ:147326489                         |
  //-------------------------------------------------------------------------/
 /*      Program(GNU GPL): EasyPiG - Easy Picture Gallery v.2.0             *|
<|*      Description: This file contains all needed functions               *|
 \*                                                                         *|
  \\-------------------------------------------------------------------------\
   \\            /)/)  File created on: 27.04.2004                            |
    \\         =(';')= Last changes on: 31.12.2004                            |
     \\        c(")(") Filename: functions.inc.php                            |
      \\  !!Your are not allowed to change or delete the copyright notice!!   |
       \*--------------------------------------------------------------------*/


######## all functions in alphabetical order


##### checks, whether cookies are accepted or not
function check_cookie($action="check") {
	switch ($action) {
		case "set":
		    // setting the test cookie
		    @setcookie("cookie_fsg_test","1",time()+3600,"/");
		    break;
		case "delete":
		    // deleting the test cookie; maybe I will need it sometime
		    @setcookie("cookie_fsg_test","1",time()-3600,"/");
		    break;
		default:
		    // checking the test cookie
			if (isset($_COOKIE['cookie_fsg_test'])) {
				return true;
			} else {
				return false;
			}
			break;
	}
}
##### validates an email address
function check_email($email) {
  	// RegEx begin
  	$nonascii      = "\x80-\xff"; # Non-ASCII-Chars are not allowed

  	$nqtext        = "[^\\\\$nonascii\015\012\"]";
  	$qchar         = "\\\\[^$nonascii]";

  	$protocol      = '(?:mailto:)';

  	$normuser      = '[a-zA-Z0-9][a-zA-Z0-9_.-]*';
  	$quotedstring  = "\"(?:$nqtext|$qchar)+\"";
  	$user_part     = "(?:$normuser|$quotedstring)";

  	$dom_mainpart  = '[a-zA-Z0-9][a-zA-Z0-9._-]*\\.';
  	$dom_subpart   = '(?:[a-zA-Z0-9][a-zA-Z0-9._-]*\\.)*';
  	$dom_tldpart   = '[a-zA-Z]{2,5}';
  	$domain_part   = "$dom_subpart$dom_mainpart$dom_tldpart";

  	$regex         = "$protocol?$user_part\@$domain_part";
  	// RegEx end

  	return preg_match("/^$regex$/",$email);
}

##### counts all images in the galleries that are given in the array
function count_images($galleries) {
	global $algorithm;
	$images = $algorithm;
	$number = 0;
	$number_of_galleries = count($galleries);
	$i = 0;
	while ($i < $number_of_galleries) {
		$file = $galleries[$i];
		$fp = fopen($file,"r");
		$j = 0;$chars = 0;
		while (!feof($fp)) {
			$chars = $chars + strlen(fgets($fp,4096));
			$number++;
			$j++;
			if ($j == $images) {
				// getting $calculated
				// 1 char = 1 Byte => $chars = Bytes
				$filesize = filesize($file);
				$size_per_image = ceil($chars/$images);
				$calculated = ceil($filesize/$size_per_image);
				$number = $number - $j + $calculated;
				break;
			}
		}
		$i++;
	}
	return $number;
}
function count_images_old($galleries) {
	$number = 0;
	$number_of_galleries = count($galleries);
	$i = 0;
	while ($i < $number_of_galleries) {
		$number = $number + count(file($galleries[$i]));
		$i++;
	}
	return $number;
}

##### extracts global vars
function extract_vars($array, &$target) {
    if (!is_array($array)) {
        return false;
    }
    $is_magic_quotes = get_magic_quotes_gpc();
    reset($array);
    while (list($key, $value) = each($array)) {
        if (is_array($value)) {
            extract_vars($value, $target[$key]);
        } elseif ($is_magic_quotes) {
            $target[$key] = stripslashes($value);
        } else {
            $target[$key] = $value;
        }
    }
    reset($array);
    return true;
}

##### are there any galleries in a category?
function exists_gallery($dir) {
	$dir_handle = opendir($dir);
    while ($file = readdir($dir_handle)) {
        if ($file != "." && $file != ".." && !is_dir($dir.$file)) {
            $tmp_file = explode(".",$file);
            if (strtolower($tmp_file[count($tmp_file)-1]) == "dat") {
				return true;
				break;
            }
        }
    }
    closedir($dir_handle);
    return false;
}

##### this will remove a directory with all its content
function fs_rmdir($dir, $del_base=true, $not_del_base_files=array()) {
	if (substr($dir,-1) != "/") {
		$dir = $dir."/";
	}
	if (is_dir($dir)) {
		$dir_handle = opendir($dir);
		while ($file = readdir($dir_handle)) {
			if ($file != "." && $file != "..") {
				if (is_dir($dir.$file)) {
					fs_rmdir($dir.$file);
				} elseif (file_exists($dir.$file) || is_link($dir.$file)) {
					$i = 0;$del = true;
					while ($i < count($not_del_base_files)) {
						if ($not_del_base_files[$i] == $file) {
							$del = false;
							break;
						}
						$i++;
					}
					if ($del) {
						if (!unlink($dir.$file)) {
							closedir($dir_handle);
							return false;
						}
					}
				} else {
					return false;
				}
			}
		}
		closedir($dir_handle);
		if ($del_base) {
			if (!rmdir($dir)) {
				return false;
			}
		}
		return true;
	} else {
		return false;
	}
}

##### returns the current GD Version
function gd_version_old() {
   	if (!extension_loaded("gd")) {
		return;
   	}
   	$gd = (function_exists("imagecreatetruecolor"))? 2 : 1;
   	return $gd;
}
function gd_version() {
    ob_start();
    phpinfo(INFO_MODULES);
    $mod_info = ob_get_contents();
    ob_end_clean();
    if (preg_match("/\bgd\s+version\b[^\d\n\r]+?([\d\.]+)/i",$mod_info,$v_number)) {
        $version_number = $v_number[1];
    } else {
        $version_number = 0;
    }
    return $version_number;
}

##### gets all available language packs
function get_all_lang() {
	$dir = "./lang/";
	$files = array();
    $dir_handle = opendir($dir);
    while ($file = readdir($dir_handle)) {
        if ($file != "." && $file != ".." && !is_dir($dir.$file)) {
            $tmp_file = explode(".",$file);
            if ((strtolower($tmp_file[count($tmp_file)-1]) == "php") && (strtolower($tmp_file[count($tmp_file)-2]) == "inc")) {
                $files[] = $file;
            }
        }
    }
    closedir($dir_handle);
    return $files;
}

##### gets all available templates
function get_all_templates() {
	$dir = "./templates/";
	$files = array();
    $dir_handle = opendir($dir);
    while ($file = readdir($dir_handle)) {
        if ($file != "." && $file != ".." && is_dir($dir.$file)) {
            $files[] = $file."/";
        }
    }
    closedir($dir_handle);
    return $files;
}

##### gets the name of a category by a path
function get_category_name($path) {
	$splitted = explode("/",$path);
	$c_name = $splitted[count($splitted)-1];
	if ($c_name == "/" || empty($c_name)) {
		$c_name = $splitted[count($splitted)-2];
	}
	return $c_name;
}

##### get the file info; needed for update plugin
function get_fileinfo($file) {
	return get_version($file) ."|". get_md5($file);
}

##### gets the name of a gallery
function get_gallery_name($file) {
	$fp = @fopen($file,"r");
	$text = @fread($fp,1024);
	$splitted = explode("|",$text);
	$fp = @fclose($fp);
	return $splitted[2];
}

##### searches for an image and gives back an array with the information about it
function get_image_information($category,$gallery,$img_id) {
	global $gallery_path;
	$path = $gallery_path.$category."/";
 	if (!is_dir($path)) {
		send_error(1);
	}
	$galleries = list_all_dbs($path);
	$i = 0;
	$max_galleries = count($galleries);
	while ($i < $max_galleries) {
		// search for the correct gallery
	    if ($gallery == get_gallery_name($galleries[$i])) {
	    	// search for the correct image and get the information
	    	$fp = @file($galleries[$i]);
	    	$j = 1;
	    	$max_images = count($fp);
			while ($j <= $max_images) {
    			if (substr($fp[$j],0,4) == $img_id) {
        			$data = explode("|",$fp[$j]);
        			break;
    			}
    			$j++;
			}
			if (empty($data) || !isset($data)) {
    			$data = explode("|",$fp[0]);
			}
			break;
	    }
	    $i++;
	}
	// the last element of the array will be the number of images in this gallery
	$data[7] = $max_images;
	if (empty($fp) || !isset($fp)) {
	    send_error(2);
	}
	return $data;
}

##### returns a link that can be used by this gallery
function get_link($uri,$file="standard") {
	global $logged_in,$getvar,$sessvar,$check_pwd;
	if ($file == "standard") {
		$file = $PHP_SELF;
	}
	if (!check_cookie()) {
		$uri .= "&". session_name() ."=". session_id();
	}
	$link = $file."?".$getvar."=". base64_encode($uri);
	return $link;
}

##### returns a md5 hash of a file; used for update plugin
##### function md5_file() does not work properly, because of misunderstanding
##### of '\n\r' by Unix and Windows systems; if you have got a better solution,
##### please send it to me: webmaster@fabian-schneider.com
function get_md5($file) {
	if (file_exists($file)) {
		$inhalt = "";
		$fp = @fopen($file,"r");
		while(!@feof($fp)) {
			$inhalt .= trim( @fgets($fp) );
		}
		$fp = @fclose($fp);
		$hash = md5($inhalt);
		return $hash;
	} else {
		return "0";
	}
}
function get_md5_old($file) {
	if (file_exists($file)) {
		return md5_file($file);
	} else {
		return "0";
	}
}

##### this function will give you a 4-digit number
function get_number($number) {
    if (strlen($number) < 4) {
        $times = 4 - strlen($number);
        $i = 0;
        while ($i < $times) {
            $number = "0".$number;
            $i++;
        }
    }
    if ($number == 0) {
        $number = "xxxx";
    }
    return $number;
}

##### this function will give back a random picture of one gallery
function get_random_images($file,$number) {
	global $thumb_path;
	$fp = file($file);
	$all_images = count($fp)-1;
	mt_srand((double)microtime()*1000000);
	// if there are not enough images in a gallery, reset $number
	if ($number > $all_images) {
		$number = $all_images+1;
	}
	$random_images = "";
	$used_images = array();
	$i = 1;
	while ($i <= $number) {
		$element = ($all_images == 0) ? 0 : mt_rand(0,$all_images);
		$data = explode("|",$fp[$element]);
		// looking, whether the random picture was already taken
		$take_it = true;
		$j = 0;
		while ($j < count($used_images)) {
			if ($data[0] == $used_images[$j]) {
				$take_it = false;
			}
			$j++;
		}
		// picture seems not to be taken, so take it
		if ($take_it) {
			$random_images .= "&nbsp;<img src=\"".$thumb_path.$data[1]."\" border=\"0\" alt=\"".$data[2]."\">";
			$used_images[] = $data[0];
			$i++;
		}
	}
	return $random_images;
}

##### returns the version of one file; needed for update plugin
function get_version($file) {
	if (!file_exists($file)) {
		return "#";
	}
	$fp = @fopen($file,"r");
	$line_1 = @fread($fp,5);
	$line_2 = trim(@fread($fp,7));
	$fp = @fclose($fp);
	if ((strlen($line_2) == 5) && (substr($line_2,0,1) == "#")) {
		return $line_2;
	} else {
		return "#";
	}
}

##### checks, whether there is already a gallery in a certain category
function is_gallery($dir,$gal_name) {
    $dir_handle = opendir($dir);$bool = false;
    while ($file = readdir($dir_handle)) {
        if ($file != "." && $file != ".." && !is_dir($dir.$file)) {
            if (get_gallery_name($dir.$file) == $gal_name) {
				$bool = true;
				return true;
				break;
            }
        }
    }
    closedir($dir_handle);
    if (!$bool) {
    	return false;
    }
}

##### lists all available databases of a dir
function list_all_dbs($dir) {
    $files = array();
    $dir_handle = opendir($dir);
    while ($file = readdir($dir_handle)) {
        if ($file != "." && $file != ".." && !is_dir($dir.$file)) {
            $tmp_file = explode(".",$file);
            if (strtolower($tmp_file[count($tmp_file)-1]) == "dat") {
                $files[] = $dir.$file;
            }
        }
    }
    closedir($dir_handle);
    return $files;
}

##### lists all available categories
function list_all_cats($dir,$mode=0) {
    $cats = array();
    $dir_handle = opendir($dir);
    while ($file = readdir($dir_handle)) {
        if (is_dir($dir.$file) && $file != "." && $file != "..") {
        	if ($mode == 0 && exists_gallery($dir.$file."/")) {
        		$cats[] = $dir.$file."/";
        	} elseif ($mode == 1) {
        		$cats[] = $dir.$file."/";
			}
        }
    }
    closedir($dir_handle);
    return $cats;
}

##### do the whole login (only used by plugins), but you can use it to protect a certain area!
function login() {
	global 	$REMOTE_ADDR,
			$HTTP_USER_AGENT,
	        $login_usr,
			$pw,
			$timelimit,
			$setup,
			$lang,
			$template_images_path,
			$logged_in,
			$check_pwd,
			$exit,
			$steps,
			$sessvar;
	
	$ip_crypted = md5($REMOTE_ADDR);
	$time = time();
	
	// do the login, because of POST data
	if (isset($_POST['pwd']) && isset($_POST['usr'])) {
		$_usr = strip_tags($_POST['usr']);
		$_pwd = md5(strip_tags($_POST['pwd']));
		if (!isset($_GET['pwd']) && !isset($_GET['usr'])) {
			if (($_usr == $login_usr) && ($_pwd == $pw)) {
				// login is correct
				$logged_in = true;
				$_SESSION['session_logged_in'] 	= true;
				$_SESSION['session_usr']        = $login_usr;
				$_SESSION['session_time']       = $time;
				$_SESSION['session_ip']         = $ip_crypted;
				$_SESSION['session_browser']    = $HTTP_USER_AGENT;
			} else {
				$msg = $lang['incorrect_login'];
			}
		}
	}

	// check the login
	if (($logged_in) && ($_SESSION['session_time'] >= $time-$timelimit) && ($_SESSION['session_ip'] == $ip_crypted) && ($_SESSION['session_browser'] == $HTTP_USER_AGENT)) {
		// for security reasons, force a new session_id by deleting the whole old session and creating a new one
		$_TMP = $_SESSION;
		
		// temporally logout
		logout();
		
		// reset $logged_in; after logout() it will be false
		$logged_in = true;
		
		// generate new session id
		mt_srand((double)microtime()*1000000);
		$random = mt_rand();
		$random = md5(uniqid($random,TRUE));
		
		// start the new session
		session_id($random);
		session_name($sessvar);
		session_start();
		
		// copy origin session data
		$_SESSION = $_TMP;
		
		// new session created, so update the time
		$_SESSION['session_time'] = $time;
	} else {
		if (!empty($_SESSION['session_time']) && ($_SESSION['session_time'] <= $time-$timelimit)) {
			$msg = $lang['login_timeout'];
		}
    	$setup .= "
					<tr>
					    <td colspan=\"2\" align=\"center\"><b>".$msg."</b><form action=\"". get_link("plugin=admin") ."\" method=\"post\"></td>
					</tr>
                    <tr>
						<td align=\"right\"><b>".$lang['user'].":</b></td>
						<td align=\"left\">&nbsp;&nbsp;<input type=\"text\" name=\"usr\" value=\"\" size=\"20\"></td>
					</tr>
					<tr>
						<td align=\"right\"><b>".$lang['pw'].":</b></td>
						<td align=\"left\">&nbsp;&nbsp;<input type=\"password\" name=\"pwd\" value=\"\" size=\"20\"></td>
					</tr>
					<tr>
						<td colspan=\"2\" align=\"center\"><input type=\"submit\" name=\"send\" value=\"".$lang['login']."\">&nbsp;<input type=\"reset\" name=\"reset\" value=\"".$lang['reset']."\"></form></td>
					</tr>\n";
		$activity = $lang['logging_in'];
		$step = 0;
    	$logged_in = false;
    	$exit = true;
		$out_array = array(
							"%setup%" => $lang['admin'],
							"%url%" => get_link("plugin=admin"),
							"%img_url%" => $template_images_path,
				    		"%version%" => $version,
				    		"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    		"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    		"%step%" => $setup,
				    		"%error_msg%" => $lang['error_msg']
							);
		parse_template("setup.html",$out_array,0);
	}
}

##### logouts a user
function logout() {
	global $logged_in;
	while (list($key,$value) = each($_SESSION)) {
		unset($_SESSION[$key]);
	}

	// delete old session
	session_destroy();
	
	// set $logged_in to false
	$logged_in = false;
}

##### parses a template;
// if $mode=0, the function will print the template directly
// if $mode=1, the function will give back the parsed template
function parse_template($template,$text,$mode){
	global $version,$starttime,$charset,$template_path;
	$template = $template_path.$template;
	// check the input
	if (!is_array($text)) {
		return false;
		break;
	}
	if (!file_exists($template)) {
		return false;
		break;
	}
	// parse the template
	$fp = fopen($template,"r");
	$output = fread($fp, filesize($template));
	fclose($fp);
	while (list($key,$value) = each($text)){
		$output = str_replace($key,$value,$output);
	}
	// additional output
	$output = str_replace("%charset%",$charset,$output);
	$stoptime = timestop();
	$neededtime = round($stoptime-$starttime,4);
	$info = "<center><a class=\"kcB\" target=\"_blank\" href=\"http://www.fabian-schneider.com\">execution time: ".$neededtime." sec. | <b>powered by EasyPiG ".$version."</b> | &copy; 2004 Fabian Schneider</a></center>\n</body>";
	if (preg_match("%exec_time%",$output)) {
		$output = str_replace("%exec_time%",$info,$output);
	} else {
		$output .= "<script language=\"JavaScript\" type=\"text/javascript\"> alert(\"You have removed the copyright notice! Please be fair and add it! This is Open Source, but the copyright has to be visible! A new copyright notice has been added automatically! Thank you! Fabian Schneider (www.fabian-schneider.com)\"); </script>";
		$output = preg_replace("'</table>'",$info,$output,1);
	}
	$output = stripslashes($output);
	// print the template
	if ($mode == 1) {
		return $output;
	} elseif ($mode == 0) {
		echo $output;
		return true;
	} else {
		return false;
	}
}

##### sends an error, if something went wrong
function send_error($error) {
	$error_code = "error_".$error;
	if (empty($lang[$error_code])) {
		$error_code = "error_default";
	}
	$out_array = array("%galleries%" => $lang[$error_code]);
	parse_template("overview.html",$out_array,0);
	// exit the program
	exit();
}

##### stops the time and gives back the time
function timestop() {
    list($sec1,$sec2) = explode(" ",microtime());
    $zeit = $sec1 + $sec2;
    return $zeit;
}

?>
