<?php
#0001 // never cut this line off! update plugin needs it!!!

		/* Copyright (c) 2004 Fabian Schneider - see '/doc/license.txt'    *\
       /*-------------------------------------------------------------------*\
      //       (>"<)                                                          |
     //        o", )            Copyright 2004 by Fabian Schneider            |
    //         (.(,) www.fabian-schneider.com  webmaster@fabian-schneider.com |
   //          '.'.J                    ICQ:147326489                         |
  //-------------------------------------------------------------------------/
 /*      Program(GNU GPL): EasyPiG - Easy Picture Gallery v.2.0             *|
<|*      Description: This script will resize images                        *|
 \*                                                                         *|
  \\-------------------------------------------------------------------------\
   \\            /)/)  File created on: 11.06.2004                            |
    \\         =(';')= Last changes on: 31.12.2004                            |
     \\        c(")(") Filename: thumbnailer.class.php                        |
      \\  !!Your are not allowed to change or delete the copyright notice!!   |
       \*--------------------------------------------------------------------*/


class Thumbnailer {
    ######### properties of the class
    var $autocreate = false; // shall we start resizing when class is being initialised?
    var $single_mode = true; // shall we only resize some selected images?
    var $image_list; // if $single_mode = true, then please type in the images which should get resized
    var $replace = false; // replace existing images?
    var $image_ext = array("gif","jpg","jpeg","png"); // available images types; do not add something!
    var $image_dir; // the original images
    var $thumb_dir; // path where to save the resized images
    var $thumb_w; // width of the resized images
    var $thumb_h; // height of the resized images
    // language options:
    var $resize_success;
    var $resize_no_success;
    
    ######### functions of this class
    ##### lists all images from a path
    function list_all_images() {
        $files = array();
        $dir_handle = opendir($this->image_dir);
        while ($file = readdir($dir_handle)) {
            if ($file != "." && $file != ".." && !is_dir($this->image_dir.$file)) {
                $tmp_file = explode(".",$file);
                $i = 0;
                while ($i < count($this->image_ext)) {
                    if ($this->image_ext[$i] == strtolower($tmp_file[count($tmp_file)-1])) {
                        $files[] = $file;
                    }
                $i++;
                }
            }
        }
        closedir($dir_handle);
        return $files;
    }
    
    ##### creates a thumbnail
    function create_thumb($filename) {
        $file = $this->image_dir.$filename;
        if ($this->replace || !file_exists($this->thumb_dir.$filename)) {
            #### file and its extension
            $tmp_file = explode(".",$file);
            $ext = strtolower($tmp_file[count($tmp_file)-1]);
            #### create the image -> different types of images!!
            if ($ext == "jpg" || $ext == "jpeg") {
                $img = imagecreatefromjpeg($file);
            } elseif ($ext == "gif") {
                $img = imagecreatefromgif($file);
            } elseif ($ext == "png") {
                $img = imagecreatefrompng($file);
            } else {
                return false;
            }
            #### read width and height
            $old_w = imagesx($img);
            $old_h = imagesy($img);
            #### get new width and height
            if ($old_w > $old_h) {
                $thumb_w = $this->thumb_w;
                $thumb_h = $old_h*($this->thumb_w/$old_w);
            }
            if ($old_w < $old_h) {
                $thumb_w = $old_w*($this->thumb_h/$old_h);
                $thumb_h = $this->thumb_h;
            }
            if ($old_w == $old_h) {
                $thumb_w = $this->thumb_w;
                $thumb_h = $this->thumb_h;
            }
            #### create the picture
            if (gd_version() < 2) {
                $new_img = imagecreate($thumb_w,$thumb_h);
                imagecopyresized($new_img,$img,0,0,0,0,$thumb_w,$thumb_h,$old_w,$old_h);
            } else {
            	$new_img = imagecreatetruecolor($thumb_w,$thumb_h);
                imagecopyresampled($new_img,$img,0,0,0,0,$thumb_w,$thumb_h,$old_w,$old_h);
            }
            #### save the picture
            if ($ext == "jpg" || $ext == "jpeg") {
                $ok = @imagejpeg($new_img,$this->thumb_dir.$filename);
                if ($ok) {
                	send(" - ".$filename." ".$this->resize_success."\\n",1);
                } else {
                	send(" - ".$filename." ".$this->resize_no_success."\\n",1);
                }
            } elseif ($ext == "gif") {
                $ok = @imagegif($new_img,$this->thumb_dir.$filename);
                if ($ok) {
                	send(" - ".$filename." ".$this->resize_success."\\n",1);
                } else {
                	send(" - ".$filename." ".$this->resize_no_success."\\n",1);;
                }
            } elseif ($ext == "png") {
                $ok = @imagepng($new_img,$this->thumb_dir.$filename);
                if ($ok) {
                	send(" - ".$filename." ".$this->resize_success."\\n",1);
                } else {
                	send(" - ".$filename." ".$this->resize_no_success."\\n",1);
                }
            } else {
                return false;
            }
            #### empty the cache
            imagedestroy($new_img);
            imagedestroy($img);
            return true;
        } else {
            return false;
        }
    }
    
    ##### will manage the resizing
    function create_thumbs() {
    	if ($this->single_mode) {
    		$files = $this->image_list;
    	} else {
        	$files = $this->list_all_images();
        }
        $i = 0;
        while ($i < count($files)) {
            $this->create_thumb($files[$i]);
            $i++;
        }
        return true;
    }

    ##### constructor of this class
    function Thumbnailer() {
        if ($this->autocreate) {
            $this->create_thumbs();
        }
    }
}

#########
## EOF ##
#########

?>
