<?php
#0001 // never cut this line off! update plugin needs it!!!

		/* Copyright (c) 2004 Fabian Schneider - see '/doc/license.txt'    *\
       /*-------------------------------------------------------------------*\
      //       (>"<)                                                          |
     //        o", )            Copyright 2004 by Fabian Schneider            |
    //         (.(,) www.fabian-schneider.com  webmaster@fabian-schneider.com |
   //          '.'.J                    ICQ:147326489                         |
  //-------------------------------------------------------------------------/
 /*      Program(GNU GPL): EasyPiG - Easy Picture Gallery v.2.0             *|
<|*      Description: This plugin will manage the creation of new galleries;*|
 \*                   to enter the plugin, call: index.php?plugin=setup     *|
  \\-------------------------------------------------------------------------\
   \\            /)/)  File created on: 11.06.2004                            |
    \\         =(';')= Last changes on: 31.12.2004                            |
     \\        c(")(") Filename: setup.inc.php                                 |
      \\  !!Your are not allowed to change or delete the copyright notice!!   |
       \*--------------------------------------------------------------------*/

##### Code of the setup plugin
################################################################################

// this script will never end...
// otherwise it is not possible to create large galleries, because of max_execution_time
@set_time_limit(0);

$setup = "<!-- Plugin: Setup Wizard for FS Galerie 2.x -->\n\n";
// first of all, let us collect all information send via POST and the FILES
// this will not be done by the main file: common.inc.php, so we have to do it
if (!empty($_POST)) {
    extract_vars($_POST, $GLOBALS);
} else if (!empty($HTTP_POST_VARS)) {
    extract_vars($HTTP_POST_VARS, $GLOBALS);
}

// how many steps will this wizard have?
$steps = 6;

// just for control...
$exit = false;

// before we can start the steps, check whether we are logged in or not
// if so, a "session id" will get created automatically, if you use get_link(string get,[string file]) for all of your links!
login();

// check, whether there is everything, the setup needs
$safe_mode = (bool) ini_get("safe_mode");
if ($safe_mode || !is_readable($tmp_path) || !is_writeable($tmp_path) || !is_writeable($gallery_path) || !is_writeable($img_path) || !is_writeable($thumb_path) || !file_exists("./lib/setup.exec.inc.php") || !file_exists("./lib/renameimg.class.php") || !file_exists("./lib/thumbnailer.class.php")) {
	$activity = "Setup is getting initialised...";
	$step = 0;
	$msg = $lang['config_error'];
	if ($safe_mode) {
		$msg = $lang['safe_mode'];
	}
	$setup = "<tr><td align=\"center\">".$msg."</td></tr>\n";
	$exit = true;
	$out_array = array(
						"%setup%" => $lang['setup'],
						"%url%" => get_link("plugin=admin"),
						"%img_url%" => $template_images_path,
				    	"%version%" => $version,
				    	"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    	"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    	"%step%" => $setup,
				    	"%error_msg%" => $lang['error_msg']
						);
	parse_template("setup.html",$out_array,0);
}

// now, start the steps, if logged in:
if (!$exit && $logged_in) {
	if (!isset($step) || empty($step)) {
		$step = 1;
	}
	// decide which step!
	switch($step) {
		case "1":
		    // decide whether to upload files or not
		    $activity = $lang['decision'];
		    $setup .= "<tr><td align=\"left\"><form name=\"decision\" action=\"". get_link("plugin=setup&step=2") ."\" method=\"post\"><input type=\"hidden\" name=\"send_files\" value=\"true\"><span class=\"error\"><b>". rawurldecode($msg) ."</b></span></td></tr>\n";
		    $setup .= "<tr><td align=\"left\"><input type=\"radio\" name=\"uploaded\" value=\"0\" onClick=\"document.decision.files.disabled = false;\"> ".$lang['upload_files']."<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".$lang['files']." <input type=\"text\" name=\"files\" value=\"\" size=\"5\" disabled> <".$max_upload."</td></tr>\n";
		    $setup .= "<tr><td align=\"left\"><input type=\"radio\" name=\"uploaded\" value=\"1\" onClick=\"document.decision.files.disabled = true;\" checked> ".$lang['uploaded_files']."</td></tr>\n";
		    $setup .= "<tr><td align=\"center\"><input type=\"submit\" name=\"submit\" value=\"".$lang['next']."\"></form></td></tr>\n";
			// parse the template
			$out_array = array(
								"%setup%" => $lang['setup'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
		case "2":
		    // get files and upload them
		    $activity = $lang['upload'];
			if (!$send_files || $files > $max_upload) {
				@header("Location: ". get_link("plugin=setup&msg=". rawurlencode($lang['too_many_files']) ) );
				exit();
			}
			if ($uploaded == 1) {
				@header("Location: ". get_link("plugin=setup&step=3&uploaded=true") );
				exit();
			}
			if ($uploaded == 0 && (empty($files) || !isset($files) || $files < 1)) {
				@header("Location: ". get_link("plugin=setup&step=1&msg=". rawurlencode($lang['no_fileamount']) ) );
				exit();
			}
			// delete other already uploaded images from temp- dir
			$image_ext = array("gif","jpg","jpeg","png");
    		$dir_handle = opendir($tmp_path);
    		while ($file = readdir($dir_handle)) {
        		if ($file != "." && $file != ".." && !is_dir($tmp_path.$file)) {
            		$tmp_file = explode(".",$file);
            		$i = 0;
            		while ($i < count($image_ext)) {
                		if ($image_ext[$i] == strtolower($tmp_file[count($tmp_file)-1])) {
							@unlink($tmp_path.$file);
                		}
            			$i++;
            		}
        		}
    		}
    		closedir($dir_handle);
    		// do the output
			$setup .= "<tr><td align=\"center\"><span class=\"error\"><b>". rawurldecode($msg) ."</b></span></td></tr>\n";
			$setup .= "<tr><td align=\"center\"><form action=\"". get_link("plugin=setup&step=3") ."\" method=\"post\" enctype=\"multipart/form-data\"><input type=\"hidden\" name=\"upload\" value=\"true\"><input type=\"hidden\" name=\"uploaded\" value=\"true\"><b>".$lang['plz_upload_files']."</b></td></tr>\n";
			$i = 0;
			while ($i < $files) {
				$j = $i+1;
				$setup .= "<tr><td align=\"center\">".$j.": <input type=\"file\" name=\"files[]\"></td></tr>\n";
				$i++;
			}
			$setup .= "<tr><td align=\"center\"><input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"".$max_imagesize."\"><input type=\"submit\" name=\"submit\" value=\"".$lang['next']."\"></form></td></tr>\n";
			// parse the template
			$out_array = array(
								"%setup%" => $lang['setup'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
		case "3":
		    // getting general information: category, gallery, widths&heights etc.
		    $activity = $lang['general_info'];
			// upload the images
			if ($upload) {
				$FILES = $_FILES;
				if (empty($FILES)) {
					$FILES = $HTTP_POST_FILES;
				}
				$number_of_files = count($FILES['files']['name']);
				$uploaded_images = 0;
				$i = 0;
				$check = false;
				while ($i < $number_of_files) {
					if (!empty($FILES['files']['name'][$i])) {
						$check = true;
					}
					$i++;
				}
				if (!$check) {
					@header("Location: ". get_link("plugin=setup&step=2&send_files=true&uploaded=false&files=".$number_of_files."&msg=". rawurlencode($lang['no_files_selected']) ) );
					exit();
				}
				if ($number_of_files > 0) {
					$gd_version = gd_version();
					$i = 0;
					while ($i < $number_of_files) {
						if (!empty($FILES['files']['name'][$i])) {
							if (($FILES['files']['size'][$i] > 0) && ($FILES['files']['size'][$i] <= $max_imagesize)) {
								$filemime = $FILES['files']['type'][$i];
								// gd > 1.6: no gif support!!! now, checking this
								$filemime_gif = false;
								if (($gd_version <= 1.6) && ($filemime == "image/gif")) {
									$filemime_gif = true;
								}
								// checking filetypes
								if ($filemime == "image/jpg" || $filemime == "image/jpeg" || $filemime == "image/pjpeg" || $filemime_gif || $filemime == "image/png") {
									$move = @copy($FILES['files']['tmp_name'][$i],$tmp_path.$FILES['files']['name'][$i]);
									if ($move) {
										$uploaded_images++;
									}
								} else {
									@header("Location: ". get_link("plugin=setup&step=2&send_files=true&uploaded=false&files=".$number_of_files."&msg=". rawurlencode($lang['wrong_mime']." ".$filemime) ) );
									exit();
								}
							} else {
								@header("Location: ". get_link("plugin=setup&step=2&send_files=true&uploaded=false&files=".$number_of_files."&msg=". rawurlencode($lang['files_too_big']) ) );
								exit();
							}
						}
						$i++;
					}
				}
				if ($uploaded_images == 0) {
					@header("Location: ". get_link("plugin=setup&step=2&send_files=true&uploaded=false&files=".$number_of_files."&msg=". rawurlencode($lang['no_files_uploaded']) ) );
					exit();
				}
				$setup .= "<tr><td colspan=\"2\" align=\"center\"><b>".$uploaded_images."/".$number_of_files." ".$lang['uploaded_text']."</b></td></tr>\n";
			}
		    // checking, whether there are any images now
			if (is_dir($tmp_path)) {
				$image_ext = array("gif","jpg","jpeg","png");
    			$dir_handle = opendir($tmp_path);
    			$ok = false;
    			while ($file = readdir($dir_handle)) {
        			if ($file != "." && $file != ".." && !is_dir($tmp_path.$file)) {
            			$tmp_file = explode(".",$file);
            			$i = 0;
            			while ($i < count($image_ext)) {
                			if ($image_ext[$i] == strtolower($tmp_file[count($tmp_file)-1])) {
                    			$ok = true;
                    			break;
                			}
            				$i++;
            			}
            			if ($ok) {
            				break;
            			}
        			}
    			}
    			closedir($dir_handle);
    			if (!$ok) {
    				@header("Location: ". get_link("plugin=setup&step=1&msg=". rawurlencode($lang['no_files']) .$old) );
    				exit();
    			}
			} else {
				@header("Location: ". get_link("plugin=setup&step=3&msg=". rawurlencode($lang['no_directory']) .$old) );
   				exit();
			}
		    $check = "checked";
		    if (!$delete_files && isset($delete_files)) {
		    	$check = "";
		    }
		    $setup .= "
		            <tr>
		                <td colspan=\"2\" align=\"center\"><form name=\"info\" action=\"". get_link("plugin=setup&step=4") ."\" method=\"post\"><b><span class=\"error\">". rawurldecode($msg) ."</span></b></td>
					</tr>
					<tr>
		                <td align=\"right\"><b>".$lang['existing_cat'].":</b></td>
		                <td align=\"left\"><select name=\"category_select\" size=\"1\">
		                    <option value=\"new\">".$lang['new_cat']."</option>";
			for($i=0;$i<count($cats);$i++) {
				$cat = get_category_name($cats[$i]);
				$setup .= "
							<option value=\"".$cat."\">".$cat."</option>";
			}
			$setup .= "
			            </select></td>
					</tr>
					<tr>
					    <td align=\"right\"><b>".$lang['new_cat'].":</b></td>
					    <td align=\"left\"><input type=\"text\" size=\"40\" name=\"category_input\" value=\"".$category_input."\"></td>
					</tr>
					<tr>
					    <td align=\"right\"><b>".$lang['gallery_name'].":</b></td>
					    <td align=\"left\"><input type=\"text\" size=\"40\" name=\"gallery\" value=\"".$gallery."\"></td>
					</tr>
    				<tr>
					    <td align=\"right\"><b>".$lang['img_width'].":</b></td>
					    <td align=\"left\"><input type=\"text\" size=\"10\" name=\"img_width\" value=\"".$img_width."\"> ".$lang['pixel']."</td>
					</tr>
    				<tr>
					    <td align=\"right\"><b>".$lang['img_height'].":</b></td>
					    <td align=\"left\"><input type=\"text\" size=\"10\" name=\"img_height\" value=\"".$img_height."\"> ".$lang['pixel']."</td>
					</tr>
    				<tr>
					    <td align=\"right\"><b>".$lang['thumb_width'].":</b></td>
					    <td align=\"left\"><input type=\"text\" size=\"10\" name=\"thumb_width\" value=\"".$thumb_width."\"> ".$lang['pixel']."</td>
					</tr>
    				<tr>
					    <td align=\"right\"><b>".$lang['thumb_height'].":</b></td>
					    <td align=\"left\"><input type=\"text\" size=\"10\" name=\"thumb_height\" value=\"".$thumb_height."\"> ".$lang['pixel']."</td>
					</tr>
					<tr>
					    <td align=\"center\" colspan=\"2\"><input type=\"checkbox\" name=\"delete_files\" value=\"true\" ".$check.">&nbsp;".$lang['delete_files']."</td>
					</tr>
					<tr>
					    <td align=\"center\" colspan=\"2\"><input type=\"submit\" name=\"next\" value=\"".$lang['next']."\"></form></td>
					</tr>\n";
					
			// parse the template
			$out_array = array(
								"%setup%" => $lang['setup'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
		case "4":
		    // 1: Rename; 2: Resize the big pictures; 3: Resize the thumbnails
		    $activity = $lang['rename_resize'];
		    ##### checking the data
		    // the category
		    $category = trim(strip_tags($category_select));
		    if ($category_select == "new") {
		    	$category = trim(strip_tags($category_input));
		    }
		    $old = "&category=". rawurlencode($category) ."&category_input=". rawurlencode($category_input) ."&gallery=". rawurlencode($gallery) ."&img_width=".$img_width."&img_height=".$img_height."&thumb_width=".$thumb_width."&thumb_height=".$thumb_height."&delete_files=".$delete_files;
		    if ($category == "new" || empty($category)) {
		    	@header("Location: ". get_link("plugin=setup&step=3&msg=". rawurlencode($lang['wrong_cat']) .$old) );
		    	exit();
		    }
		    $gallery = trim(strip_tags($gallery));
			// check, whether there are images inside the dir
			if (is_dir($tmp_path)) {
				$image_ext = array("gif","jpg","jpeg","png");
    			$dir_handle = opendir($tmp_path);$up_img = 0;
    			while ($file = readdir($dir_handle)) {
        			if ($file != "." && $file != ".." && !is_dir($tmp_path.$file)) {
            			$tmp_file = explode(".",$file);
            			$i = 0;
            			while ($i < count($image_ext)) {
                			if ($image_ext[$i] == strtolower($tmp_file[count($tmp_file)-1])) {
                    			$ok = true;
								$up_img++;
                			}
            				$i++;
            			}
        			}
    			}
    			closedir($dir_handle);
    			if (!$ok) {
    				@header("Location: ". get_link("plugin=setup&step=1&msg=". rawurlencode($lang['no_files']) .$old) );
    				exit();
    			}
			} else {
				@header("Location: ". get_link("plugin=setup&step=3&msg=". rawurlencode($lang['no_directory']) .$old) );
   				exit();
			}
		    
		    // the widths and heights
		    $img_width = round($img_width);$img_height = round($img_height);
		    $thumb_width = round($thumb_width);$thumb_height = round($thumb_height);
		    if (($img_width <= 0 || $img_width > $img_max_size) || ($img_height <= 0 || $img_height > $img_max_size) || ($thumb_width <= 0 || $thumb_width > $img_max_size) || ($thumb_height <= 0 || $thumb_height > $img_max_size)) {
       			@header("Location: ". get_link("plugin=setup&step=3&msg=". rawurlencode($lang['wrong_width_height']) .$old) );
       			exit();
       		}
       		
			// everything seems to be o.k., so create a new folder, if necessary
			if ($category_select == "new") {
				// does the dir already exists? if so, we do not have to create it!
				$bool_dir = false;
				if (!is_dir($gallery_path.$category)) {
					$old_umask = umask(0);
					$bool_dir = mkdir($gallery_path.$category,0777);
					umask($old_umask);
					// copying the index.html, so nobody can access the directory, if .htaccess is not supported
					@copy($data_path."index.html",$gallery_path.$category."/index.html");
				} else {
					$bool_dir = true;
				}
				if ($bool_dir) {
					$setup .= "<tr><td align=\"center\"><b>".$lang['path_created']."</b></td></tr>\n";
				} else {
					$setup .= "<tr><td align=\"center\"><b><span class=\"error\">".$lang['path_not_created']."</span></b></td></tr>\n";
				}
			}
			
			// now, checking the gallery
		    if (empty($gallery) || is_gallery($gallery_path.$category."/",$gallery)) {
		    	@header("Location: ". get_link("plugin=setup&step=3&msg=". rawurlencode($lang['wrong_gal']) .$old) );
		    	exit();
		    }
		    
			// status
			$setup .= "<tr><td>&nbsp;</td></tr>\n";
			$setup .= "<tr><td><p align=\"justify\">".$lang['wait']."</p></td></tr>\n";
			$setup .= "<tr><td align=\"center\"><img src=\"".$template_images_path."loading.gif\" alt=\"".$lang['wait']."\" border=\"0\"></td></tr>\n";
			$setup .= "<tr><td align=\"center\"><form name=\"message\"><textarea name=\"texts\" cols=\"50\" rows=\"10\"></textarea></form></td></tr>\n";
			$setup .= "<tr><td align=\"center\" width=\"100%\">
			                <table height=\"20\" width=\"90%\" cellspacing=\"1\" cellpadding=\"0\" class=\"highlight2\">
							<tr>
								<td class=\"normal\">
								<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\" align=\"center\">
								<tr>";
			$width = round(100 / ($up_img * 3),5);
			for ($i=1;$i<=$up_img*3;$i++) {
				$setup .= "<td id=\"zelle".$i."\" class=\"normal\" width=\"".$width."%\" height=\"20\"></td>\n";
			}
			                
			$setup .= "
			                    </tr>
			                    </table>
								</td>
			                </tr>
			                </table>
			            </td>
					</tr>\n";
			$setup .= "<tr><td align=\"center\"><span id=\"prozent\"><b>0%</b></span><!--<input type=\"text\" name=\"prozent\" value=\"\" size=\"5\" readonly>--></td></tr>\n";
			$setup .= "<tr><td align=\"center\"><form action=\"". get_link("plugin=setup&step=5".$old) ."\" name=\"next\" method=\"post\"><input type=\"hidden\" name=\"send_but\" value=\"true\"><input type=\"hidden\" name=\"files\" value=\"\"><input type=\"submit\" name=\"next_button\" value=\"".$lang['next']."\" disabled></form></td></tr>\n";

			// parse the template
			$out_array = array(
								"%setup%" => $lang['setup'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
			// this script will resize and rename all images
			define("FS_GALERIE_PLUGIN_SETUP",$version);
			include("./lib/setup.exec.inc.php");
		    break;
		case "5":
		    // collecting the information for every picture
		    $activity = $lang['collecting_info'];
		    if (!$send_but) {
		    	@header("Location: ". get_link("plugin=setup") );
		    	exit();
		    }
		    // the images
		    $files = rawurldecode($files);
		    $files_imploded = $files;
		    $files = explode("|",$files);
		    // the form and the images
		    $max = count($files);
		    $setup .= "<tr><td colspan=\"2\"><form action=\"javascript:setall();\" name=\"setall\"></td></tr>\n";
		    $setup .= "
		                <tr>
		                    <td align=\"right\"><b>".$lang['photographer'].":</b></td>
		                    <td align=\"left\"><input type=\"text\" size=\"30\" name=\"copy_all\" value=\"\"></td>
						</tr>
						<tr>
						    <td align=\"right\"><b>".$lang['email'].":</b></td>
						    <td align=\"left\"><input type=\"text\" size=\"30\" name=\"email_all\" value=\"\"></td>
						</tr>
						<tr>
						    <td colspan=\"2\" align=\"center\"><input type=\"submit\" name=\"submit\" value=\"".$lang['set']."\"></form></td>
						</tr>
						<tr>
							<td colspan=\"2\"><hr></td>
						</tr>\n";
		    $setup .= "<tr><td colspan=\"2\"><form name=\"information\" onSubmit=\"return check()\" action=\"". get_link("plugin=setup&step=6&category=".$category."&gallery=".$gallery."&delete_files=".$delete_files) ."\" method=\"post\"></td></tr>\n";
		    $i = 0;
		    while ($i < $max) {
		    	$setup .= "
		    	            <tr>
		    	                <td align=\"left\" valign=\"middle\"><img src=\"".$thumb_path.$files[$i]."\" border=\"0\" alt=\"\"></td>
		    	                <td align=\"center\">
		    	                <table width=\"100%\" cellspacing=\"0\" cellpadding=\"5\">
		    	                <tr>
		    	                    <td align=\"right\"><b>".$lang['title'].":</b></td>
		    	                    <td align=\"left\"><input type=\"text\" size=\"30\" name=\"info[".$i."][title]\" value=\"\"></td>
								</tr>
		    	                <tr>
		    	                    <td align=\"right\"><b>".$lang['description'].":</b></td>
		    	                    <td align=\"left\"><input type=\"text\" size=\"30\" name=\"info[".$i."][description]\" value=\"\"></td>
								</tr>
		    	                <tr>
		    	                    <td align=\"right\"><b>".$lang['photographer'].":</b></td>
		    	                    <td align=\"left\"><input type=\"text\" size=\"30\" name=\"info[".$i."][copy]\" value=\"\">*</td>
								</tr>
		    	                <tr>
		    	                    <td align=\"right\"><b>".$lang['email'].":</b></td>
		    	                    <td align=\"left\"><input type=\"text\" size=\"30\" name=\"info[".$i."][copy_email]\" value=\"\">*</td>
								</tr>
								</table>
								</td>
							</tr>
							<tr>
							    <td colspan=\"2\"><hr></td>
							</tr>\n";
		    	$i++;
		    }
		    $setup .= "<tr><td align=\"center\" colspan=\"2\"><input type=\"hidden\" name=\"final\" value=\"true\"><input type=\"hidden\" name=\"images\" value=\"".$max."\"><input type=\"hidden\" name=\"files\" value=\"".$files_imploded."\"><input type=\"submit\" name=\"submit\" value=\"".$lang['finish']."\"></form></td></tr>\n";
			// parse the template
			$out_array = array(
								"%setup%" => $lang['setup'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
		case "6":
		    // writing the database -> success message
		    $activity = $lang['creating_gallery'];
		    if (!$final) {
		    	@header("Location: ". get_link("plugin=setup") );
		    	exit();
		    }
		    $files = explode("|",$files);
		    $filename = strip_tags(trim(strtolower(str_replace(" ","_",rawurldecode($gallery))))).".dat";
		    $fp = fopen($gallery_path. rawurldecode($category) ."/".$filename,"w");
		    $i = 0;
		    while ($i < $images) {
		    	if (empty($info[$i]['description'])) {
		    		$desc = "xxx";
		    	} else {
		    		$desc = $info[$i]['description'];
		    	}
		    	$break = ($i < $images-1) ? "\n" : "";
		    	$fileinfo = get_number($i+1)."|".$files[$i]."|". rawurldecode($gallery) ."|".$info[$i]['title']."|".$desc."|".$info[$i]['copy']."|".$info[$i]['copy_email'].$break;
		    	fwrite($fp,$fileinfo);
		    	if ($delete_files) {
		    		@unlink($tmp_path.$files[$i]);
		    	}
		    	$i++;
		    }
		    $fp = fclose($fp);
			$setup .= "<tr><td align=\"center\"><a href=\"". get_link("plugin=admin") ."\"><b>".$lang['finished']."</b></a></td></tr>\n";
		    // parse the template
			$out_array = array(
								"%setup%" => $lang['setup'],
								"%url%" => get_link("plugin=admin"),
								"%img_url%" => $template_images_path,
				    			"%version%" => $version,
				    			"%action%" => "<b>".$lang['action'].":</b> ".$activity,
				    			"%steps%" => "<b>".$lang['step'].":</b> ".$step."/".$steps,
				    			"%step%" => $setup,
				    			"%error_msg%" => $lang['error_msg']
								);
			parse_template("setup.html",$out_array,0);
		    break;
	}
}

##### should the main script be stopped?
################################################################################
$stop = true;

?>
